Moved check_perms() into rsync.fns and tweaked how it is called.
[rsync/rsync.git] / testsuite / rsync.fns
... / ...
CommitLineData
1#! /bin/sh
2
3# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5# General-purpose test functions for rsync.
6
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License version
9# 2 as published by the Free Software Foundation.
10#
11# This program is distributed in the hope that it will be useful, but
12# WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14# Lesser General Public License for more details.
15#
16# You should have received a copy of the GNU Lesser General Public
17# License along with this program; if not, write to the Free Software
18# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
20
21tmpdir="$scratchdir"
22fromdir="$tmpdir/from"
23todir="$tmpdir/to"
24chkdir="$tmpdir/chk"
25
26# Berkley's nice.
27PATH="$PATH:/usr/ucb"
28
29if diff -u "$srcdir/testsuite/rsync.fns" "$srcdir/testsuite/rsync.fns" >/dev/null 2>&1; then
30 diffopt="-u"
31else
32 diffopt="-c"
33fi
34
35HOME="$scratchdir"
36export HOME
37
38runtest() {
39 echo $ECHO_N "Test $1: $ECHO_C"
40 if eval "$2"
41 then
42 echo "$ECHO_T done."
43 return 0
44 else
45 echo "$ECHO_T failed!"
46 return 1
47 fi
48}
49
50# Call this if you want to filter out verbose messages (-v or -vv) from
51# the output of an rsync run (whittling the output down to just the file
52# messages). This isn't needed if you use -i without -v.
53filter_outfile() {
54 sed -e '/^building file list /d' \
55 -e '/^created directory /d' \
56 -e '/^done$/d' \
57 -e '/ --whole-file$/d' \
58 -e '/^total: /d' \
59 -e '/^$/,$d' \
60 <"$outfile" >"$outfile.new"
61 mv "$outfile.new" "$outfile"
62}
63
64printmsg() {
65 echo "$1"
66}
67
68rsync_ls_lR() {
69 find "$@" -print | sort | sed 's/ /\\ /g' | xargs "$TOOLDIR/tls"
70}
71
72check_perms() {
73 "$TOOLDIR/tls" "$1" | grep "^-$2" >/dev/null
74}
75
76rsync_getgroups() {
77 "$TOOLDIR/getgroups"
78}
79
80
81####################
82# Build test directories $todir and $fromdir, with $fromdir full of files.
83
84hands_setup() {
85 # Clean before creation
86 rm -rf "$fromdir"
87 rm -rf "$todir"
88
89 [ -d "$tmpdir" ] || mkdir "$tmpdir"
90 [ -d "$fromdir" ] || mkdir "$fromdir"
91 [ -d "$todir" ] || mkdir "$todir"
92
93 # On some BSD systems, the umask affects the mode of created
94 # symlinks, even though the mode apparently has no effect on how
95 # the links behave in the future, and it cannot be changed using
96 # chmod! rsync always sets its umask to 000 so that it can
97 # accurately recreate permissions, but this script is probably run
98 # with a different umask.
99
100 # This causes a little problem that "ls -l" of the two will not be
101 # the same. So, we need to set our umask before doing any creations.
102
103 # set up test data
104 touch "$fromdir/empty"
105 mkdir "$fromdir/emptydir"
106
107 # a hundred lines of text or so
108 rsync_ls_lR "$srcdir" > "$fromdir/filelist"
109
110 echo $ECHO_N "This file has no trailing lf$ECHO_C" > "$fromdir/nolf"
111 umask 0
112 ln -s nolf "$fromdir/nolf-symlink"
113 umask 022
114
115 cat "$srcdir"/*.c > "$fromdir/text"
116 mkdir "$fromdir/dir"
117 cp "$fromdir/text" "$fromdir/dir"
118 mkdir "$fromdir/dir/subdir"
119 echo some data > "$fromdir/dir/subdir/foobar.baz"
120 mkdir "$fromdir/dir/subdir/subsubdir"
121 if [ -r /etc ]; then
122 ls -ltr /etc > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
123 else
124 ls -ltr / > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
125 fi
126 mkdir "$fromdir/dir/subdir/subsubdir2"
127 if [ -r /bin ]; then
128 ls -lt /bin > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
129 else
130 ls -lt / > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
131 fi
132
133# echo testing head:
134# ls -lR "$srcdir" | head -10 || echo failed
135}
136
137
138####################
139# Many machines do not have "mkdir -p", so we have to build up long paths.
140# How boring.
141makepath () {
142 echo " makepath $1"
143 p="$1"
144 (
145 # Absolut Unix.
146 if echo $p | grep '^/' >/dev/null
147 then
148 cd /
149 fi
150
151 # This will break if $1 contains a space.
152 for c in `echo $p | tr '/' ' '`
153 do
154 if [ -d "$c" ] || mkdir "$c"
155 then
156 cd "$c" || return $?
157 else
158 echo "failed to create $c" >&2; return $?
159 fi
160 done
161 )
162}
163
164
165
166###########################
167# Run a test (in '$1') then compare directories $2 and $3 to see if
168# there are any difference. If there are, explain them.
169
170# So normally basically $1 should be an rsync command, and $2 and $3
171# the source and destination directories. This is only good when you
172# expect to transfer the whole directory exactly as is. If some files
173# should be excluded, you might need to use something else.
174
175checkit() {
176 failed=
177
178 # We can just write everything to stdout/stderr, because the
179 # wrapper hides it unless there is a problem.
180
181 echo "Running: \"$1\""
182 eval "$1"
183 status=$?
184 if [ $status != 0 ]; then
185 failed="YES";
186 fi
187
188 echo "-------------"
189 echo "check how the directory listings compare with diff:"
190 echo ""
191 ( cd "$2" && rsync_ls_lR . ) > "$tmpdir/ls-from"
192 ( cd "$3" && rsync_ls_lR . ) > "$tmpdir/ls-to"
193 diff $diffopt "$tmpdir/ls-from" "$tmpdir/ls-to" || failed=YES
194
195 echo "-------------"
196 echo "check how the files compare with diff:"
197 echo ""
198 if [ "x$4" != x ]; then
199 echo " === Skipping (as directed) ==="
200 else
201 diff -r $diffopt "$2" "$3" || failed=YES
202 fi
203
204 echo "-------------"
205 if [ -z "$failed" ] ; then
206 return 0
207 else
208 return 1
209 fi
210}
211
212
213build_rsyncd_conf() {
214 # Build an appropriate configuration file
215 conf="$scratchdir/test-rsyncd.conf"
216 echo "building configuration $conf"
217
218 port=2612
219 pidfile="$scratchdir/rsyncd.pid"
220 logfile="$scratchdir/rsyncd.log"
221
222 cat >"$conf" <<EOF
223# rsyncd configuration file autogenerated by $0
224
225pid file = $pidfile
226use chroot = no
227hosts allow = localhost, 127.0.0.1
228log file = $logfile
229exclude = foobar.baz
230max verbosity = 9
231
232uid = 0
233gid = 0
234
235[test-from]
236 path = $fromdir
237 read only = yes
238
239[test-to]
240 path = $todir
241 read only = no
242EOF
243}
244
245
246build_symlinks() {
247 mkdir "$fromdir"
248 date >"$fromdir/referent"
249 ln -s referent "$fromdir/relative"
250 ln -s "$fromdir/referent" "$fromdir/absolute"
251 ln -s nonexistent "$fromdir/dangling"
252 ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
253}
254
255test_fail() {
256 echo "$@" >&2
257 exit 1
258}
259
260test_skipped() {
261 echo "$@" >&2
262 echo "$@" > "$tmpdir/whyskipped"
263 exit 77
264}
265
266# It failed, but we expected that. don't dump out error logs,
267# because most users won't want to see them. But do leave
268# the working directory around.
269test_xfail() {
270 echo "$@" >&2
271 exit 78
272}
273
274# Determine what shell command will appropriately test for links.
275ln -s foo "$scratchdir/testlink"
276for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
277do
278 for switch in -h -L
279 do
280 if $cmd $switch "$scratchdir/testlink" 2>/dev/null
281 then
282 # how nice
283 TEST_SYMLINK_CMD="$cmd $switch"
284 # i wonder if break 2 is portable?
285 break 2
286 fi
287 done
288done
289# ok, now get rid of it
290rm "$scratchdir/testlink"
291
292
293if [ "x$TEST_SYMLINK_CMD" = 'x' ]
294then
295 test_fail "Couldn't determine how to test for symlinks"
296else
297 echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
298fi
299
300
301# Test whether something is a link, allowing for shell peculiarities
302is_a_link() {
303 # note the variable contains the first option and therefore is not quoted
304 $TEST_SYMLINK_CMD "$1"
305}
306
307
308# We need to set the umask to be reproducible. Note also that when we
309# do some daemon tests as root, we will setuid() and therefore the
310# directory has to be writable by the nobody user in some cases. The
311# best thing is probably to explicitly chmod those directories after
312# creation.
313
314umask 022